<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
       "http://www.w3.org/TR/html4/loose.dtd">
<html lang="de">
<head>
	<title>
<?show_title()?>
	</title>
	<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
	<meta http-equiv="Content-Style-Type" content="text/css">
<?show_meta()?>
	<link rel="Shortcut Icon" href="favicon.ico" type="image/x-icon">
	<link rel="StyleSheet" href="style.css" type="text/css">
</head>

<body>
	<table class=mytable cellspacing=0 cellpadding=0 border=0>
	<colgroup>
		<col width="20">
		<col>
	</colgroup>
	
<tbody>
<tr>
	<td class="mylogo">
		<a href="?show=."><img class="pic_logo" src="logo.png" alt="Home" title="Home"></a>
	</td>
	<td class="myheader">
<?show_position()?>
	</td>
</tr>
<tr>
	<td class="mysidebar" valign="top">
	<div class="ro"><div class="lo"><div class="ru"><div class="lu">
	<div class="mynavigator">
	<ul>
<?generate_menu()?>
	</ul>
	</div>
	</div></div></div></div>
	</td>
	<td>
	<a name=top></a>
	<div class=mybody>
<?show_file()?><br>
	<a class="mytop" href="#top" title="Zum Seitenanfang">TOP</a>
	</div>
	</td>
</tr>
<tr>
	<td class="mydate">
<?readfile ("date.txt")?>
	</td>
	<td class="mybottom">
<?generate_banner()?>
	</td>
	</tr>
</table>

</body>
</html>

<?php  /** PHP Funktionen
@Author: Markus Raab
@Licence: LPGL

Dieses Framework ermglicht ein Mensystem, eine Bildervorschau
ein Newssystem und einige andere kleine Features.

Um flexibel zu bleiben und nicht bei jeder Seite die php-
Funktionen abzundern, gibt es eine vorgeschriebene Ordner-
struktur, mit der man dann aber flexibel Inhalte auf der
Seite verteilt ausgeben kann.

Das Design wird komplett ber ein Stylesheet verwaltet.

Ordnerstruktur root:
/
|
| - index.php (Dieses Skript)
| - about.html (In der Hauptseite angezeigt)
| - [greeting.html] (oben im Titel)
| - date.txt (ganz links unten)
| - standard.html (wird gezeigt, falls in einem Unterordner
|	kein index.html vorhanden ist)
| - logo.png (Bild welches rechts oben angezeigt wird)
| - style.css (Stylesheet fr alle Seiten)
|
\ - pic (Ausgeblendeter Ordner fr Bilder)
\ - banner (Ausgeblendeter Ordner fr banner-Bilder unten)

In der root werden alle zustzlichen Dateien ausgeblendet!

Beliebiger Ordner
|
| - index.html (Startseite wenn Ordner angewhlt wird)
| - [greeting.html] (wird statt obiger Navigation angezeigt)
| - images.html (Zeigt an, wenn es sich um Bilder handelt)
| - news.html (Zeigt an, wenn es sich um eine Newsseite handelt)

*/

/**Gibt Dateiname zurck*/
function get_filename()
{
	$filename = $_GET['show'];

	if ($filename == "" || $filename == ".")
	{
		$filename = "about.html";
	} else if (is_dir($filename))
	{
		if (file_exists("$filename/news.html"))
			$filename .= "/news.html";
		else if (file_exists("$filename/images.html"))
			$filename .= "/images.html";
		else $filename .= "/index.html";
	}
	return $filename;
}

/**Findet heraus ob eine Extension als Text
 * interpretiert werden soll.*/
function is_txt_extension ($extension)
{
	switch ($extension) {
	case ".txt": 
	case ".c": case ".cpp":
	case ".h":
	case ".log":
	case ".sh":
	return true;
	}
	return false;
}

/**Zeigt den Titel in der Titelleiste des Browsers an.*/
function show_title()
{
	$dirname = dirname (get_filename());
	if (file_exists ("$dirname/title.txt"))
	{
		readfile ("$dirname/title.txt");
		return;
	}
	if ($pathname == "")
	{
		echo "Home\n"; 
		return;
	}
	$pathname = format_dir($dirname);
	echo $pathname;
}

function show_meta()
{
	$dirname = dirname (get_filename());
	if ($dirname != "." && file_exists ("meta.html"))
		readfile ("meta.html");
	if (file_exists ("$dirname/meta.html"))
		readfile ("$dirname/meta.html");
}


/**Zeigt die aktuelle Position rechts oben an. Wenn ein
 * greeting.html im Ordner enthalten ist, wird stattessen
 * dieses angezeigt.*/
function show_position()
{
	$filename = get_filename();
	$pathname = dirname($filename);
	$positions = split ("/", $pathname);

	if (is_file($pathname."/"."greeting.html"))
		readfile ($pathname."/"."greeting.html"); 
	else {
		echo '		<ul id="list">' . "\n";
		echo '			<li><a href="?show=.">Home</a></li>' . "\n";
		foreach ($positions as $pos) {
			$full .= $pos;
			$full .= "/";
		echo '			<li><a href="?show=' .
				$full .	'">' . format_dir($pos) .
				"</a></li>\n";
		}
		echo "		</ul>\n";
	}
}

/**Datei ausgeben*/
function show_file ()
{
	$filename = get_filename();
	$pos = strpos($filename,".");
	if ($pos == false)
	{	// Wenn keine Erweiterung, nimm txt an!
		$extension = ".txt";
	} else {
		$extension = substr($filename,$pos);
	}

	if (is_txt_extension ($extension)) echo "<pre>\n";
	if (file_exists ($filename))
	{
		readfile ($filename);
	} else {
		readfile ("standard.html");
	}
	if (is_txt_extension ($extension)) echo "\n</pre>";
	
	if (basename($filename) == "images.html") {
		generate_images (dirname($filename));
	}

	if (basename($filename) == "news.html") {
		generate_news (dirname($filename));
	}
	
	echo "\n";
}

/**Gibt den Dateinamen aus*/
function show_file_name ($file, $fileselected)
{
	$name = basename($file);
	$pos = strpos($name,".");
	$isbin = false;
	if ($pos == false)
	{	// Wenn keine Erweiterung, nimm txt an!
		$extension = ".txt";
		$pre = $name;
	} else {
		$extension = substr($name,$pos);
		if ($extension == ".html" || $extension == ".txt")
			$pre = substr($name,0,$pos);
		else $pre = $name;
	}	
	$dir = dirname ($file);
	
	echo '			<li class="';
	if (basename($file) == $fileselected)
		print 'file_selected';
	else if (is_executable ($file))
	{
		print 'file_bin';
		$isbin = true;
	}
	else if ($extension == ".html") {
		print 'file_html';
	}
	else if (is_txt_extension ($extension)) {
		print 'file_txt';
	} else {
		print 'file_bin'; 
		$isbin = true; 
	}
	if ($isbin) echo '"> <a href="' ,
			$file . '">' ,	basename ($pre) ,
			'</a></li>', "\n";
	else echo '"> <a href="index.php?show=' ,
			$file . '">' ,	basename ($pre) ,
			'</a></li>', "\n";
}

/**Gibt ein formatierten Namen einer Datei zurck.
 * "Ordner/4Datei" wird zu "Datei". Die erste Zahl
 * kann deshalb zum Sortieren von Dateien und Ordner
 * verwendet werden.*/
function format_dir ($entry)
{
	$entry = basename($entry);
	if (ereg("[0-9]", $entry))
	{
		$entry = substr($entry,1);
	}
	return $entry;
}

/** generate_menu erstellt eine Liste von Dateinamen.
  * Das Men wird ber 'show' erhalten.
  *
  * Bsp: www.text.org/index.php?show=Ordner
  * In diesem Beispiel wrde Ordner verwendet werden
  * und alle enthaltenen Dateien im Men dargestellt
  * werden.
  *
  * Aus den Dateiname wird der Pfad gewonnen. Wenn der
  * Dateiname bereits ein Verzeichnis ist, wird index.html
  * angenommen. Einzige Ausnahme ist das root Verzeichnis.
  * Dort wird about.html angzeigt, da es sonst zu Konflikte
  * mit dem Webserver kommen k&ouml;nnte, wenn index.html +
  * index.php vorhanden ist.
  */
function generate_menu ()
{
	$filename = get_filename();
	$fileselected = basename ($filename);

	if ($fileselected == "news.html")
		$filename = dirname($filename);
	else if ($fileselected == "images.html")
		$filename = dirname($filename);

	$pathname = dirname($filename);

	$dirs = array();	// Ein Array f&uuml;r die Verzeichnisse
	$files = array();	// Ein Array f&uuml;r Dateien
	$prevdirs = array();	// Ein Array fr darber liegende Verzeichnisse

	/**********************************************************
	***********       Verzeichnisse auslesen      *************
	**********************************************************/

	$dir = dir($pathname);
	while ($entry = $dir->read()) {	
		if (	$entry == "." ||
			$entry == ".." || 
			$entry == "banner" ||
			$entry == "pic") 
			continue;
		if ($pathname != ".")
			$entry = $pathname . "/" . $entry;
		if (is_dir($entry)) 
		{
			$dirs[] = $entry;
		} else
		{
			$add=true;
			switch(basename($entry)) {
			case "index.html":
			case "greeting.html":
			case "title.txt":
			case "meta.html":
				$add=false;
			}
			if ($add) $files[] = $entry;
		}
	}
	$dir->close();
	
	if ($pathname != ".")	// keine vorige Ebene vorhanden
	{
		$pdir = dir(dirname($pathname));
		while ($entry = $pdir->read()) {
			if (	$entry == "." ||
				$entry == ".." || 
				$entry == "banner" ||
				$entry == "pic") 
				continue;
			if (is_dir (dirname($pathname) . "/" . $entry))
				$prevdirs[] = $entry;
		}
		$pdir->close();
	} else {
		$prevdirs[] = $pathname;
	}

	sort($prevdirs);
	sort($dirs);
	sort($files);
	
	/**********************************************************
	***********        Home/Zurck ausgeben       *************
	**********************************************************/
	
	if ($pathname == ".")	// erste Ebene
	{
		echo '		<li class="';
		if ($fileselected == "news.html") echo "file_folder";
		else if ($fileselected == "images.html") echo "file_folder";
		else echo "file_selected";
		echo '"> <a href="index.php?show=.">Home</a></li>', "\n";
	}
	else if (dirname($pathname) == ".")	// zweite Ebene
	{
		echo '		<li class="file_folder"> <a href="index.php?',
			'show=.">Home</a></li>', "\n";

	} else {	// andere Ebene
		echo '		<li class="file_folder"> <a href="index.php?show=' .
		dirname($pathname) . '">Zur&uuml;ck</a></li>', "\n";
	}
	

	/**********************************************************
	***********       Menstruktur ausgeben       *************
	**********************************************************/

	foreach ($prevdirs as $prevdir)
	{
		if (dirname($pathname) == ".") $prevdir = $prevdir;
		else $prevdir = dirname($pathname) . "/" . $prevdir;
		if (strcmp($prevdir, $pathname))
		{
			echo '		<li class="file_folder"> <a href="index.php?show=' , 
			$prevdir , '">' , 
			format_dir ($prevdir) , '</a></li>' , "\n";
		} else {
			if ($prevdir !=".")
			{
				echo '		<li class="';
				if ($fileselected == "index.html") echo "file_selected";
				else echo "file_folder";	// gerade nicht ausgewhlt
				echo '"> <a href="index.php?show=' , 
				$prevdir , '">' , 
				format_dir ($prevdir) , '</a></li>' , "\n";
			}

			if ($pathname != ".") echo '		<li class="mysmaller"><ul>' . "\n";
			foreach ($dirs as $dir) {
				echo '			<li class="';
				if (($fileselected == "images.html" && $filename == $dir) ||
					($fileselected == "news.html" && $filename == $dir)	)
					echo "file_selected";
				else echo "file_folder";
				echo '"> <a href="index.php?show=' , 
				$dir , '">' , 
				format_dir ($dir) , '</a></li>' , "\n";
			}
			if ($pathname == ".") continue;	// in root keine Dateien anzeigen
			
			foreach ($files as $file) show_file_name ($file, $fileselected);
			echo '		</ul></li>' . "\n";
		}
	}
} //ende function generate menu

/**Generiert aus dem Ordner banner eine Bildervorschau
 * die rechts unten angezeigt wird. Eine gleichnamige .txt
 * Datei kann verwendet werden um einen Link fr dieses
 * Bild zu bestimmen*/
function generate_banner()
{
	$dir = dir("banner");
	while ($entry = $dir->read()) {	
		if (	$entry == '.'||
			$entry == '..' ||
			ereg (".txt$", $entry))
			continue;
		echo '		<a href="';
		readfile ("banner/$entry.txt");
		echo '		">';
		echo '<img class="pic_banner" src="banner/',$entry,'" alt="',$entry,'">';
		echo "</a>", "\n";
	}
	$dir->close();
}

/**Diese Funktion generiert Nachrichten. Damit erkannt wird,
 * dass es sich um einen Ordner mit Nachrichten handelt die
 * Datei news.html anlegen. Alle weiteren html Dateien werden
 * als Nachrichten betrachtet.
 * Sie werden je nach Erstellungsdatum sortiert*/
function generate_news($folder)
{
	echo "<table>";
	$files = array();
	$dir = dir("$folder");
	while ($entry = $dir->read()) {	
		if (	$entry == '.'||
			$entry == '..' ||
			$entry == "news.html")
			continue;
		$fullpath="$folder/$entry";
		$mtime = filemtime ($fullpath);
		$f = array($fullpath => $mtime);
		$files = array_merge ($files, $f);
	}
	$dir->close();

	arsort ($files, SORT_NUMERIC);
	
	foreach ($files as $entry => $time)
	{
		echo "\t".'<tr class="newsheading">' . "\n";
		echo "\t\t".'<td width="80%"><h2>' . 
			ereg_replace(".html","",basename($entry)) . "</h2></td>\n\t\t".
			'<td width="20%">' .	date ("F d Y H:i:s", $time) .
			"</td>\n\t\t</tr>\n";
		echo "\t<tr>\n\t\t".'<td class="newsfooting" colspan=2>'."\n";
		readfile ("$entry");
		echo "\t\t</td>\n\t</tr>\n";
	}
	echo "</table>";
}

/**Generiert Bilder in einem Ordner. Damit erkannt
 * wird, dass dieser Ordner eine Bildervorschau
 * erstellen soll, muss eine Datei images.html
 * angelegt werden.*/
function generate_images($folder)
{
	$files = array();
	$dir = dir("$folder");
	while ($entry = $dir->read()) {	
		if (	$entry == '.'||
			$entry == '..' ||
			$entry == "images.html")
			continue;
		$fullpath="$folder/$entry";
		$mtime = filemtime ($fullpath);
		$f = array($fullpath => $mtime);
		$files = array_merge ($files, $f);
	}
	$dir->close();

	arsort ($files, SORT_NUMERIC);
	
	$num = -1;
	echo "\t\t<table>";
	echo "\t\t" . '<tr class="pic_tr">' . "\n";
	foreach ($files as $entry => $time)
	{
		if ($num++ == 2) {
			echo "\t\t</tr>\n\t\t" . '<tr class="pic_tr">' . "\n";
			$num = 0;
		}
		echo "\t\t\t<td><h2>" .
			ereg_replace(".jpg","",basename($entry)) . "</h2>\n" .
			"\t\t\t<p class=pic_date>" . date ("F d Y H:i:s", $time) . "</p>\n";
		echo "\t\t\t".'<a href="' . "pic/$entry" . '"><img alt="' . $entry . 
			'" src="' . $entry . '"></a>';
		echo "</td>\n";
	}
	echo "</tr>";
	echo "</table>";
}

?>
